# Management API Overview

The SingleStore `Management` API provides a REST-based interface for provisioning, configuring, operating, and managing cloud resources within SingleStore Helios. The API is designed to support infrastructure automation, lifecycle management, and seamless integration with DevOps, CI/CD, and infrastructure-as-code workflows, enabling you to automate deployment pipelines, dynamically scale environments, enforce governance policies, manage operational workflows, and more.

This RESTful API allows you to perform the following operations:

* **Workspace groups**: Create, update, or delete workspace groups, request information on available workspace groups, list the workspace groups
* **Workspaces**: Create, update, suspend, resume, or delete workspaces, request information on workspaces, list the workspaces, get the outbound allowlist for a workspace
* **Projects**: List the projects accessible to a user
* **Private connections**: Create, update, or delete private connections, request information on private connections
* **Flow**: Create or terminate a Flow instance, request information on a Flow instance, list the Flow instances
* **Invitations**: Invite a user, revoke an invitation, list the open invitations, request information on an invitation
* **Teams**: Create, update, or delete a team for the current organisation, request information on a team, list the teams
* **Users**: Add an existing user to the current organization, delete a user, request information on a user, list the users
* **Roles**: Create, update, or delete a custom role, request information on a role, list the roles
* **Jobs**: Create, update, or delete a job, request information on jobs, list the jobs
* **Stage**:

  * Create, update, or delete a folder in a Stage, request information on a folder
  * Upload, download, modify, or delete a file in a Stage
* **Files**: Create, upload, update, download, or delete a file in the personal, shared, or model space, list the files, request information on a file
* **Secrets**: Create, update, or delete a secret, request information on a secret, list the secrets
* **Audit logs**: Request Control Plane audit log entries
* **Organizations**: Request information on current organization
* **Billing**: Get raw compute and storage usage information for your organization
* **Shared Edition** (Shared Tier):

  * Create or delete a Shared Edition deployment (starter workspace), request information on a starter workspace, list the starter workspaces
  * Create, update, or delete a user in a Shared Edition deployment
* **Cloud workload identity and delegated entities**: Request information on the cloud workload identity of a workspace, add or remove delegated entities, list the configured delegated entities
* **Regions**: List the regions for a user

The `Management` API supports [HTTP Bearer authentication](https://swagger.io/docs/specification/authentication/bearer-authentication/), which must be used in conjunction with SSL (HTTPS) for secure communication over the network. API calls made over HTTP will fail. For more information, refer to [Authorization](https://docs.singlestore.com/cloud/reference/management-api.md).

You can also interface with the `Management` API from [SingleStore Notebooks](https://docs.singlestore.com/cloud/container-services/notebooks.md) using the [Fusion SQL](https://docs.singlestore.com/cloud/reference/fusion-sql.md) commands.

## Authorization

The `Management` API authenticates requests using a unique, hex-encoded alphanumeric key. You can generate this API key on the [Cloud Portal](https://portal.singlestore.com/).

When a user is a member of multiple organizations, they can have multiple API keys, one for each organization. The API key defines the operations that a user can perform.

## Generate an API Key

Follow these instructions to generate API keys:

1. On the Cloud Portal, in the navigation pane, select your organization.

2. In the navigation pane, select **Configuration > API keys > Active Keys > Create API key**.

3. Specify a name and expiration date for the API key, and select **Create**.

> **❗ Important**: The API key is displayed **only once**. Be sure to copy and securely store the API key.

## Revoke an API Key

To revoke an API key, navigate to the **API keys** section under **Configuration** on the Cloud Portal. On the **Active Keys** tab, select the delete icon under the **Actions** column for the API key, and select **Revoke**.

API keys that are not manually revoked expire on the expiration date defined while creating the API key. A revoked API key cannot be reinstated.

## Control Access to the API

SingleStore recommends using **IP Allowlist** to secure inbound access to workspaces using the `Management` API.

To allow an IP address, login to the [Cloud Portal](https://portal.singlestore.com/). Under your organization, select **Configuration >&#x20;****API Keys > Security > Edit > Only allow access from specified IP addresses**. Under **IP Allowlist**, add the IP address to allow.

![A dialog box for editing IP Address Access.](https://images.contentstack.io/v3/assets/bltac01ee6daa3a1e14/blt46f0c53e5c2c3ea9/6a305345b29fb626135a44bf/ip_allowlist-dUs6D6.png)

By default, IP Allowlist is set to **Allow access from anywhere**, which allows access to anyone with the API key.

## Access the Management API

SingleStore’s `Management` API supports [HTTP Bearer authentication](https://swagger.io/docs/specification/authentication/bearer-authentication/). To access the API, you must provide your API key in the Authorization header in each HTTP request. An example Authorization header is as follows.

```
Authorization: Bearer 28790ecd46256d9024e7b21a737493b2ed2872e6883808a87843d1ce9839d0d3
```

While making API calls through an HTTP client (such as cURL), you can pass the API key using the `-H` parameter:

```shell
curl -X 'GET' \
  'api_endpoint_url' \
  -H 'accept: application/json' \
  -H 'Authorization: Bearer <API_key>'

```

## Workspaces

A Workspace is an independent logical deployment of compute resources which can be used to run a workload in lieu of a cluster. A database can be shared across multiple workspaces through R/W (read/write) and R/O (read only) attachments. Contact [SingleStore Support](https://support.singlestore.com) for access to the workspaces and the API.

Each workspace is a part of a workspace group, which allows configuration and management of workspaces. An organization can have multiple workspace groups, and each workspace group can have up to five workspaces.

## Connect to a Workspace

Once a workspace becomes active, use the workspace endpoint to establish a SQL connection in conjunction with the admin user and password (password for the workspace group). Here is a sample connection:

```shell
singlestore -h svc-xxxx-1-dml.aws-cancentral-1.svc.singlestore.com -u admin --password='QUNL@S|(})jZX1VDOp%*EMzm'
```

## Attach a Database

After connecting to a workspace endpoint, execute the `CREATE DATABASE` command to create the specified database and attach it to the workspace in the read-write mode.

Refer to [Attach a Database to a Workspace](https://docs.singlestore.com/cloud/reference/sql-reference/operational-commands/attach-database/#section-idm4562675609292833157466852139.md) for more information.

## Detach a Database

Refer to [Detach a Database from a Workspace](https://docs.singlestore.com/cloud/reference/sql-reference/operational-commands/detach-database/#section-idm4562675561145633157492898422.md) for more information.

## Manage the API using Golang Client

The [singlestore-go](https://github.com/singlestore-labs/singlestore-go) repository is a collection of SingleStore Golang SDKs. The modules in the `management` package in the Golang SDK can be used to interact with the `Management` API.

To import the SDK, add the following line to your `*.go` file:

```go
import "github.com/singlestore-labs/singlestore-go/management"
```

For more information, see [Management API Golang SDK documentation](https://pkg.go.dev/github.com/singlestore-labs/singlestore-go/management). Here’s a [sample project](https://github.com/singlestore-labs/regions-lister) that uses the `Management` API Golang client.

## References

* [Stage](https://docs.singlestore.com/cloud/load-data/load-data-from-files/stage.md)
* [Secrets](https://docs.singlestore.com/cloud/developer-resources/secrets.md)
* [Connect with Private Services and Networks](https://docs.singlestore.com/cloud/connect-to-singlestore/private-connections.md)

## In this section

* [Management API Reference](https://docs.singlestore.com/cloud/reference/management-api/reference.md)

***

Modified at: May 26, 2026

Source: [/cloud/reference/management-api/](https://docs.singlestore.com/cloud/reference/management-api/)

(An index of the documentation is available at /llms.txt)
